//  Demo 26: SumSeriesApplet.java
//
//  Add up the first N terms of the series 1 - 1/3 + 1/5 - 1/7 ...     
//
//             by Charles W. Neville
//      Copyright Charles W. Neville, June, 1999
//
// Four times the above series converges to a very familiar number.  Run this 
// Applet and try to guess what this very familiar number is.

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class SumSeries extends Applet implements ActionListener {

   double sum = 0, sign;
   int N = 0;

   TextField limitField;
   Button   okButton;

   public void init() {

      Label limitLabel;
      limitLabel = new Label("Enter number of terms");
      add(limitLabel);

      limitField = new TextField(10);
      add(limitField);

      okButton = new Button("OK");
      okButton.addActionListener(this);
      add(okButton);


   } // init

   public void actionPerformed(ActionEvent e) {

      N = Integer.parseInt(limitField.getText());
      sum = 0;  sign = -1;

      for(int n = 1; n <= N; n = n + 2) {

        sign = -sign;
        sum = sum + sign/n;

      } // for

      repaint();

   } // actionPerformed

   public void paint(Graphics g) {

     g.drawString("The sum of the first " + N + " terms of the series", 50, 100);
     g.drawString(" 1 - 1/3 + 1/5 - 1/7 ... ", 70, 120);
     g.drawString(" = " + sum, 50, 140);

     g.drawString("And the sum times 4 is", 50, 180);
     g.drawString(" = " + 4*sum, 50, 200);

   } // paint

} // class SumSeries